- Aldebaran documentation |
- C++ Libraries |
- index

libqi-api 2.8.7.4

- Main Page
- Related Pages
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Member Functions | List of all members
qi::ListTypeInterface Class Referenceabstract

`#include <typeinterface.hpp>`

## Public Member Functions
virtual TypeInterface * | elementType ()=0
| Get the type of the elements of the list. More...
virtual size_t | size (void *storage)=0
| Return the number of elements in the list. More...
virtual AnyIterator | begin (void *storage)=0
| Return an iterator pointing to the first element of the list. More...
virtual AnyIterator | end (void *storage)=0
virtual void | pushBack (void **storage, void *valueStorage)=0
| Append an element to the end of the list. More...
virtual void * | element (void *storage, int index)
| Get the element at index. More...
TypeKind | kind () override
Public Member Functions inherited from qi::TypeInterface
virtual | ~TypeInterface ()=default
virtual const TypeInfo & | info ()=0
| Get the TypeInfo corresponding to this type. More...
virtual void * | initializeStorage (void *ptr=nullptr)=0
virtual void * | ptrFromStorage (void **)=0
virtual void * | clone (void *)=0
| Allocate a storage and copy the value given as an argument. More...
virtual void | destroy (void *)=0
| Free all resources of a storage. More...
virtual bool | less (void *a, void *b)=0
const char * | infoString ()
qi::Signature | signature (void *storage=nullptr, bool resolveDynamic=false)

## Additional Inherited Members
Static Public Member Functions inherited from qi::TypeInterface
static TypeInterface * | fromSignature (const qi::Signature &sig)

## Detailed Description

Interface for a list of elements (like std::vector)

Elements must have the same types (may be dynamic)

Definition at line 188 of file typeinterface.hpp.

## Member Function Documentation

virtual AnyIterator qi::ListTypeInterface::begin | ( | void * | storage | ) |
| pure virtual

Return an iterator pointing to the first element of the list.

Implemented in qi::VarArgsTypeInterfaceImpl< T >, qi::VarArgsTypeInterfaceImpl< qi::VarArguments< T > >, qi::ListTypeInterfaceImpl< std::set< T > >, qi::ListTypeInterfaceImpl< qi::VarArguments< T >::VectorType, VarArgsTypeInterface >, qi::ListTypeInterfaceImpl< std::vector< T > >, qi::ListTypeInterfaceImpl< std::list< T > >, and qi::ListTypeInterfaceImpl< T::VectorType, VarArgsTypeInterface >.

virtual void* qi::ListTypeInterface::element | ( | void * | storage,
|  | int | index
| ) |  |
| virtual

Get the element at index.

virtual TypeInterface* qi::ListTypeInterface::elementType | ( |  | ) |
| pure virtual

Get the type of the elements of the list.

Implemented in qi::ListTypeInterfaceImpl< std::set< T > >, qi::ListTypeInterfaceImpl< qi::VarArguments< T >::VectorType, VarArgsTypeInterface >, qi::ListTypeInterfaceImpl< std::vector< T > >, qi::ListTypeInterfaceImpl< std::list< T > >, and qi::ListTypeInterfaceImpl< T::VectorType, VarArgsTypeInterface >.

virtual AnyIterator qi::ListTypeInterface::end | ( | void * | storage | ) |
| pure virtual

Return an iterator pointing to one past the last element of the list (do not dereference this iterator!)

Implemented in qi::VarArgsTypeInterfaceImpl< T >, qi::VarArgsTypeInterfaceImpl< qi::VarArguments< T > >, qi::ListTypeInterfaceImpl< std::set< T > >, qi::ListTypeInterfaceImpl< qi::VarArguments< T >::VectorType, VarArgsTypeInterface >, qi::ListTypeInterfaceImpl< std::vector< T > >, qi::ListTypeInterfaceImpl< std::list< T > >, and qi::ListTypeInterfaceImpl< T::VectorType, VarArgsTypeInterface >.

TypeKind qi::ListTypeInterface::kind | ( |  | ) |
| inline override virtual

Get the kind of the data.

This is used to downcast the TypeInterface object to a specialized interface.

Reimplemented from qi::TypeInterface.

Reimplemented in qi::VarArgsTypeInterface.

Definition at line 204 of file typeinterface.hpp.

virtual void qi::ListTypeInterface::pushBack | ( | void ** | storage,
|  | void * | valueStorage
| ) |  |
| pure virtual

Append an element to the end of the list.

Implemented in qi::VarArgsTypeInterfaceImpl< T >, qi::VarArgsTypeInterfaceImpl< qi::VarArguments< T > >, qi::ListTypeInterfaceImpl< std::set< T > >, qi::ListTypeInterfaceImpl< qi::VarArguments< T >::VectorType, VarArgsTypeInterface >, qi::ListTypeInterfaceImpl< std::vector< T > >, qi::ListTypeInterfaceImpl< std::list< T > >, and qi::ListTypeInterfaceImpl< T::VectorType, VarArgsTypeInterface >.

virtual size_t qi::ListTypeInterface::size | ( | void * | storage | ) |
| pure virtual

Return the number of elements in the list.

Implemented in qi::VarArgsTypeInterfaceImpl< T >, qi::VarArgsTypeInterfaceImpl< qi::VarArguments< T > >, qi::ListTypeInterfaceImpl< std::set< T > >, qi::ListTypeInterfaceImpl< qi::VarArguments< T >::VectorType, VarArgsTypeInterface >, qi::ListTypeInterfaceImpl< std::vector< T > >, qi::ListTypeInterfaceImpl< std::list< T > >, and qi::ListTypeInterfaceImpl< T::VectorType, VarArgsTypeInterface >.

The documentation for this class was generated from the following file:

- /home/opennao/work/release-2.8/sdk/libqi/qi/type/typeinterface.hpp